#include "initlib.h"

#include <dlfcn.h>

static int initlibcurl(void);

int initlib(int lib)
{
   int ret = -1;

   switch(lib) {
      case LIBCURL:
         ret = initlibcurl();
         break;
   }

   return ret;
}

static int initlibcurl(void)
{
   int ret = -1;

   do {
      if(!(libcurl = dlopen("libcurl.so", RTLD_NOW))) break;
      if(!(*(void **)(&P_curl_global_init) = dlsym(libcurl, "curl_global_init"))) break;
      if(!(*(void **)(&P_curl_easy_init) = dlsym(libcurl, "curl_easy_init"))) break;
      if(!(*(void **)(&P_curl_slist_append) = dlsym(libcurl, "curl_slist_append"))) break;
      if(!(*(void **)(&P_curl_easy_setopt) = dlsym(libcurl, "curl_easy_setopt"))) break;
      if(!(*(void **)(&P_curl_easy_cleanup) = dlsym(libcurl, "curl_easy_cleanup"))) break;
      if(!(*(void **)(&P_curl_slist_free_all) = dlsym(libcurl, "curl_slist_free_all"))) break;
      if(!(*(void **)(&P_curl_easy_perform) = dlsym(libcurl, "curl_easy_perform"))) break;
      ret = 0;
   } while(0);

   if(ret == -1) {
      if(P_curl_global_init) P_curl_global_init = NULL;
      if(P_curl_easy_init) P_curl_easy_init = NULL;
      if(P_curl_slist_append) P_curl_slist_append = NULL;
      if(P_curl_easy_setopt) P_curl_easy_setopt = NULL;
      if(P_curl_easy_cleanup) P_curl_easy_cleanup = NULL;
      if(P_curl_slist_free_all) P_curl_slist_free_all = NULL;
      if(P_curl_easy_perform) P_curl_easy_perform = NULL;
      if(libcurl) {
         dlclose(libcurl);
         libcurl = NULL;
      }
   }

   return ret;
}
